     H dftactgrp(*no) actgrp(*caller)
     H option(*srcstmt: *nodebugio)

     FCBPRINTF  o    e             printer oflind(bOverflow)

     D* =============== begin *ENTRY PLIST =======================
     D CBEXAMPLE2      pr                  extpgm('CBEXAMPLE2')
     D  parmStatus                    8a
     D CBEXAMPLE2      pi
     D  parmStatus                    8a
     D* ================ end *ENTRY PLIST ========================

     D CurrDate        s             10a
     D CurrTime        s              8a
     D bEOF            s               n
     D bOverflow       s               n
     D Status          s                   like(parmStatus)
     D SqlNormal       c                   const('00000')
     D SqlEod          c                   const('02000')

     D/copy copybooks,psds

      * Host variables to be filled by SQL command
     D xCompany        s                   like(Company)
     D xCustNbr        s                   like(CustNbr)
     D xInvDate        s                   like(InvDate)
     D xInvoice        s                   like(Invoice)
     D xItem           s                   like(Item)
     D xQty            s                   like(Qty)
     D xPrice          s                   like(Price)
     D xExtPrice       s                   like(ExtPrice)
     D xSlsRep         s                   like(SlsRepNo)

     D xCompanyNull    s              5i 0
     D xCustNbrNull    s              5i 0
     D xInvDateNull    s              5i 0
     D xInvoiceNull    s              5i 0
     D xItemNull       s              5i 0
     D xQtyNull        s              5i 0
     D xPriceNull      s              5i 0
     D xExtPriceNull   s              5i 0
     D xSlsRepNull     s              5i 0

      * control break save fields
     D cb10            s                   like(xSlsRep)
     D cb10Save        s                   like(cb10)
     D cb20A           s                   like(xCompany)
     D cb20ASave       s                   like(cb20a)
     D cb20B           s                   like(xCustNbr)
     D cb20BSave       s                   like(cb20b)
     D cb30            s                   like(xInvDate)
     D cb30Save        s                   like(cb30)

     D Null10          s              5i 0
     D Null10Save      s              5i 0
     D Null20A         s              5i 0
     D Null20ASave     s              5i 0
     D Null20B         s              5i 0
     D Null20BSave     s              5i 0
     D Null30          s              5i 0
     D Null30Save      s              5i 0

      * sum fields and counters
     D Qty00           s             +1    like(xQty)
     D Qty10           s                   like(Qty00)
     D Qty20           s                   like(Qty00)
     D Qty30           s                   like(Qty00)
     D ExtPrice00      s                   like(ExtPrice)
     D ExtPrice10      s                   like(ExtPrice00)
     D ExtPrice20      s                   like(ExtPrice00)
     D ExtPrice30      s                   like(ExtPrice00)

     C/exec sql
     C+
     C+    declare c1 cursor for
     C+       SELECT h.COMPANY, h.CUSTNBR,
     C+              h.INVDATE, h.INVOICE,
     C+              d.item, d.qty, d.price,
     C+              decimal(d.qty * d.price,9,2) as Extended,
     C+              c.slsrepno
     C+         FROM invhdr as h
     C+         LEFT JOIN invdtl as d
     C+           ON h.invoice = d.invoice
     C+         LEFT JOIN customer as c
     C+           ON h.company = c.company
     C+          AND h.custnbr = c.custnbr
     C+        ORDER BY c.slsrepno, h.company, h.custnbr, h.invdate
     C+    for read only
     C/end-exec

     C                   exsr      inz
     C                   exsr      PrintHeadings
     C                   exsr      OpenCursor
     C                   exsr      Read
     C
     C                   if        not bEOF
     C                   exsr      BgnLvl00
     C                   dow       not bEOF
     C                   exsr      CheckCtlBreak
     C                   exsr      CheckOverflow
     C                   exsr      BuildDetail
     C                   exsr      Read
     C                   enddo
     C                   exsr      EndLvl00
     C                   endif
     C
     C                   exsr      ShutDown
     C* =======================================================
     C* OpenCursor: Open the SQL cursor for input
     C* =======================================================
     C     OpenCursor    begsr
     C
     C/exec sql
     C+   open c1
     C/end-exec
     C                   if        SQLStt <> SQLNormal
     C                   eval      Status = '10-' + SQLStt
     C                   exsr      ShutDown
     C                   endif
     C
     C                   endsr
     C* =======================================================
     C* Read: retrieve a row from the SQL cursor
     C* =======================================================
     C     Read          begsr
     C
     C/exec SQL
     C+    Fetch c1 into :xCompany  :xCompanyNull,
     C+                  :xCustNbr  :xCustNbrNull,
     C+                  :xInvDate  :xInvDateNull,
     C+                  :xInvoice  :xInvoiceNull,
     C+                  :xItem     :xItemNull,
     C+                  :xQty      :xQtyNull,
     C+                  :xPrice    :xPriceNull,
     C+                  :xExtPrice :xExtPriceNull,
     C+                  :xSlsRep   :xSlsRepNull
     C/end-exec
     C
     C                   if        SQLStt <> SQLNormal
     C                             and SQLStt <> SQLEod
     C                   eval      Status = '20-' + SQLStt
     C                   exsr      ShutDown
     C                   endif
     C
     C                   eval      bEOF = (SQLStt <> SQLNormal)
     C
     C                   if        not bEOF
     C* copy input fields to to control break variables here
     C                   eval      Null10 = xSlsRepNull
     C                   eval      Null20a = xCompanyNull
     C                   eval      Null20b = xCustNbrNull
     C                   eval      Null30 = xInvDateNull
     C                   if        Null10 = *zero
     C                   eval      cb10 = xSlsRep
     C                   endif
     C                   if        Null20a = *zero
     C                   eval      cb20a = xCompany
     C                   endif
     C                   if        Null20b = *zero
     C                   eval      cb20b = xCustNbr
     C                   endif
     C                   if        Null30 = *zero
     C                   eval      cb30 = xInvDate
     C                   endif
     C                   endif
     C
     C                   endsr
     C* =======================================================
     C* CheckOverflow: check for page overflow
     C* =======================================================
     C     CheckOverflow begsr
     C
     C                   if        bOverflow
     C                   exsr      PrintHeadings
     C                   eval      bOverflow = *off
     C                   endif
     C
     C                   endsr
     C* =======================================================
     C* PrintHeadings: print page headings
     C* =======================================================
     C     PrintHeadings begsr
     C
     C                   write     PageHdr
     C
     C                   endsr
     C* =======================================================
     C* CheckCtlBreak: check for a control break
     C* =======================================================
     C     CheckCtlBreak begsr
     C
     C                   select
     C                   when      cb10 <> cb10Save
     C                              or Null10 <> Null10Save
     C                   exsr      EndLvl10
     C                   exsr      BgnLvl10
     C                   when      cb20a <> cb20aSave
     C                              or Null20a <> Null20aSave
     C                              or cb20b <> cb20bSave
     C                              or Null20b <> Null20bSave
     C                   exsr      EndLvl20
     C                   exsr      BgnLvl20
     C                   when      cb30 <> cb30Save
     C                              or Null30 <> Null30Save
     C                   exsr      EndLvl30
     C                   exsr      BgnLvl30
     C                   endsl
     C
     C                   endsr
     C* =======================================================
     C* BuildDetail: Load and print the detail line
     C* =======================================================
     C     BuildDetail   begsr
     C
     C                   reset                   detail
     C                   if        xCompanyNull = *zero
     C                   eval      Company = xCompany
     C                   endif
     C                   if        xCustNbrNull = *zero
     C                   eval      CustNbr = xCustNbr
     C                   endif
     C                   if        xInvDateNull = *zero
     C                   eval      InvDate = xInvDate
     C                   endif
     C                   if        xInvoiceNull = *zero
     C                   eval      Invoice = xInvoice
     C                   endif
     C                   if        xItemNull = *zero
     C                   eval      Item = xItem
     C                   endif
     C                   if        xQtyNull = *zero
     C                   eval      Qty = xQty
     C                   eval      Qty30 += Qty
     C                   endif
     C                   if        xPriceNull = *zero
     C                   eval      Price = xPrice
     C                   endif
     C                   if        xExtPriceNull = *zero
     C                   eval      ExtPrice = xExtPrice
     C                   eval      ExtPrice30 += ExtPrice
     C                   endif
     C                   write     detail
     C
     C                   endsr
     C* =======================================================
     C* BgnLvl00: one-time calcs before the first control group
     C* =======================================================
     C     BgnLvl00      begsr
     C
     C                   exsr      BgnLvl10
     C
     C                   endsr
     C* =======================================================
     C* BgnLvl10: begin major control group
     C* =======================================================
     C     BgnLvl10      begsr
     C
      * save control break fields
     C                   eval      cb10Save = cb10
     C                   eval      Null10Save = Null10
      * print headings for this level
     C                   if        Null10 = *zero
     C                   eval      *in61 = *on
     C                   eval      SlsRepNo = xSlsRep
     C                   else
     C                   eval      *in61 = *off
     C                   clear                   SlsRepNo
     C                   endif
     C                   write     Hdr1
      * clear accumulators for this level
     C                   clear                   Qty10
     C                   clear                   ExtPrice10
      * force breaks at lower levels
     C                   exsr      BgnLvl20
     C
     C                   endsr
     C* ======================================4================
     C* BgnLvl20: begin intermediate control group
     C* =======================================================
     C     BgnLvl20      begsr
     C
      * save control break fields
     C                   eval      cb20aSave = cb20a
     C                   eval      Null20aSave = Null20a
     C                   eval      cb20bSave = cb20b
     C                   eval      Null20bSave = Null20b
      * print headings for this level
      * clear accumulators for this level
     C                   clear                   Qty20
     C                   clear                   ExtPrice20
      * force breaks at lower levels
     C                   exsr      BgnLvl30
     C
     C                   endsr
     C* =======================================================
     C* BgnLvl30: begin minor control group
     C* =======================================================
     C     BgnLvl30      begsr
     C
      * save control break fields
     C                   eval      cb30Save = cb30
     C                   eval      Null30Save = Null30
      * print headings for this level
      * clear accumulators for this level
     C                   clear                   Qty30
     C                   clear                   ExtPrice30
      * force breaks at lower levels
     C
     C                   endsr
     C* =======================================================
     C* EndLvl00: one-time calcs after the last control group
     C* =======================================================
     C     EndLvl00      begsr
     C
      * force breaks at lower levels
     C                   exsr      EndLvl10
      * accumulate to higher levels
      * print totals
     C                   eval      TotDesc = 'Grand totals'
     C                   eval      TotQty = Qty00
     C                   eval      TotExt = ExtPrice00
     C                   write     Total
     C
     C                   endsr
     C* =======================================================
     C* EndLvl10: end major control group
     C* =======================================================
     C     EndLvl10      begsr
     C
      * force breaks at lower levels
     C                   exsr      EndLvl20
      * accumulate to higher levels
     C                   eval      Qty00 += Qty10
     C                   eval      ExtPrice00 += ExtPrice10
      * print totals
     C                   eval      TotDesc = 'Rep totals'
     C                   eval      TotQty = Qty10
     C                   eval      TotExt = ExtPrice10
     C                   write     Total
     C
     C                   endsr
     C* =======================================================
     C* EndLvl20: end intermediate control group
     C* =======================================================
     C     EndLvl20      begsr
     C
      * force breaks at lower levels
     C                   exsr      EndLvl30
      * accumulate to higher levels
     C                   eval      Qty10 += Qty20
     C                   eval      ExtPrice10 += ExtPrice20
      * print totals
     C                   eval      TotDesc = 'Customer totals'
     C                   eval      TotQty = Qty20
     C                   eval      TotExt = ExtPrice20
     C                   write     Total
     C
     C                   endsr
     C* =======================================================
     C* EndLvl30: end minor control group
     C* =======================================================
     C     EndLvl30      begsr
     C
      * force breaks at lower levels
      * accumulate to higher levels
     C                   eval      Qty20 += Qty30
     C                   eval      ExtPrice20 += ExtPrice30
      * print totals
     C                   eval      TotDesc = 'Date totals'
     C                   eval      TotQty = Qty30
     C                   eval      TotExt = ExtPrice30
     C                   write     Total
     C
     C                   endsr
     C* =======================================================
     C* Shutdown: end the program
     C* =======================================================
     C     Shutdown      begsr
     C
     C                   eval      *inlr = *on
     C/exec SQL
     C+    close c1
     C/end-exec
     C                   if        %parms > *zero
     C                   eval      parmStatus = Status
     C                   endif
     C
     C                   return
     C
     C                   endsr
     C* =======================================================
     C* inz: first-time-only calculations
     C* =======================================================
     C     inz           begsr
     C
     C                   endsr
